import "./style.css";
import { reactive as L, ref as N, watchEffect as w, onActivated as j, nextTick as x, onBeforeUnmount as B, resolveComponent as p, openBlock as D, createElementBlock as P, createElementVNode as l, createVNode as g, withCtx as A, withDirectives as T, vShow as F } from "vue";
import { Button as O } from "@opentiny/vue";
import { VueMonaco as W, CloseIcon as U, LinkButton as V } from "@opentiny/tiny-engine-common";
import { useModal as H, useCanvas as h, useNotify as I, useHelp as J } from "@opentiny/tiny-engine-controller";
import { initCompletion as z } from "@opentiny/tiny-engine-controller/js/completion";
import { lint as R, initLinter as Y } from "@opentiny/tiny-engine-controller/js/linter";
import { theme as q } from "@opentiny/tiny-engine-controller/adapter";
import { insertName as G, string2Ast as E, formatString as K, ast2String as Q } from "@opentiny/tiny-engine-controller/js/ast";
import { constants as X } from "@opentiny/tiny-engine-utils";
import { isFunction as Z } from "@opentiny/vue-renderless/grid/static";
const { SCHEMA_DATA_TYPE: $ } = X, { message: tt, confirm: et } = H(), s = L({
  linterWorker: null,
  script: "",
  isChanged: !1,
  hasError: !1,
  editorSelection: null,
  completionProvider: null
}), a = N(null);
let f = null;
const v = () => {
  var t, o;
  const e = ((o = (t = h().canvasApi.value).getSchema) == null ? void 0 : o.call(t)) || {};
  return e.methods = (e == null ? void 0 : e.methods) || {}, e.methods;
}, ot = () => h().pageState.pageSchema && Object.keys(v()) || [], M = () => {
  const t = Object.entries(v()).map(([o, n]) => G(o, n.value)).join(`
`);
  return f = E(t), t;
}, nt = (e) => {
  if (s.isChanged = e !== s.script, !a.value)
    return;
  const t = a.value.getEditor().getModel();
  R(t, s.linterWorker);
}, y = ({ name: e, content: t }) => {
  if (!e)
    return;
  const o = v();
  o[e] || (o[e] = {
    type: $.JSFunction,
    value: ""
  }), o[e].value = t;
}, b = () => {
  if (!s.isChanged)
    return !1;
  if (s.hasError)
    return tt({
      status: "error",
      message: "代码静态检查有错误，请先修改后再保存"
    }), !1;
  const e = a.value.getEditor().getValue(), t = E(e);
  return h().canvasApi.value.getSchema().methods = {}, t.program.body.forEach((o, n) => {
    var d, u;
    const r = (d = o == null ? void 0 : o.id) == null ? void 0 : d.name;
    (u = t.program.body[n + 1]) != null && u.leadingComments && o.trailingComments === t.program.body[n + 1].leadingComments && delete o.trailingComments;
    const i = K(Q(o).trim(), "javascript");
    y({ name: r, content: i });
  }), h().setSaved(!1), s.isChanged = !1, I({
    type: "success",
    message: "保存成功！"
  }), !0;
}, st = (e) => (t) => {
  const o = Z(t) ? t : () => e("close");
  if (!s.isChanged) {
    o(!0);
    return;
  }
  et({
    title: "提示",
    message: "有改动未保存，您确定保存并关闭吗？",
    exec() {
      o(b());
    },
    cancel() {
      o(!0);
    }
  });
}, rt = () => {
  if (!s.editorSelection || !a.value)
    return;
  const e = a.value.getEditor();
  e.setSelection(s.editorSelection), e.focus();
  const t = e.getTopForLineNumber(s.editorSelection.startLineNumber - 1);
  e.setScrollPosition(
    {
      scrollLeft: 0,
      scrollTop: t
    },
    0
  );
}, it = (e) => {
  var n;
  if (!e)
    return;
  const t = f == null ? void 0 : f.program.body.filter((r) => {
    var i;
    return e === ((i = r == null ? void 0 : r.id) == null ? void 0 : i.name);
  });
  if (t.length === 0)
    return;
  const o = (n = t[0]) == null ? void 0 : n.loc;
  o && (s.editorSelection = {
    startColumn: o.start.column,
    startLineNumber: o.start.line,
    endColumn: o.end.column + 1,
    endLineNumber: o.end.line
  }), s.editorSelection && rt();
}, ct = ({ emit: e }) => (w(() => {
  s.script = M();
}), j(() => {
  x(() => {
    var t;
    s.script = M(), (t = a.value) == null || t.focus(), window.dispatchEvent(new Event("resize"));
  });
}), {
  state: s,
  monaco: a,
  change: nt,
  saveMethods: b,
  close: st(e)
});
const lt = (e, t) => {
  const o = e.__vccOpts || e;
  for (const [n, r] of t)
    o[n] = r;
  return o;
}, at = {
  saveMethod: y,
  highlightMethod: it,
  getMethodNameList: ot,
  getMethods: v
}, dt = {
  components: {
    MonacoEditor: W,
    TinyButton: O,
    CloseIcon: U,
    LinkButton: V
  },
  emits: ["close"],
  setup(e, { emit: t }) {
    const o = J().getDocsUrl("script"), { state: n, monaco: r, change: i, close: d, saveMethods: u } = ct({ emit: t }), _ = {
      roundedSelection: !0,
      automaticLayout: !0,
      autoIndent: !0,
      language: "javascript",
      formatOnPaste: !0,
      tabSize: 2,
      theme: q(),
      minimap: {
        enabled: !1
      },
      // 禁用滚动条边边一直显示的边框
      overviewRulerBorder: !1,
      renderLineHighlightOnlyWhenFocus: !0
    }, C = (m) => {
      var c;
      r.value && (n.completionProvider = z(r.value.getMonaco(), (c = r.value.getEditor()) == null ? void 0 : c.getModel()), n.linterWorker = Y(m, r.value.getMonaco(), n));
    };
    return B(() => {
      var m, c, S;
      (m = n.completionProvider) == null || m.forEach((k) => {
        k.dispose();
      }), (S = (c = n.linterWorker) == null ? void 0 : c.terminate) == null || S.call(c);
    }), {
      state: n,
      monaco: r,
      options: _,
      close: d,
      change: i,
      saveMethods: u,
      editorDidMount: C,
      docsUrl: o
    };
  }
}, ut = { class: "plugin-page-js-container" }, mt = { class: "code-edit-head" }, pt = { class: "head-left" }, gt = { class: "head-right" }, ft = { class: "dots" }, ht = { class: "code-edit-content" };
function vt(e, t, o, n, r, i) {
  const d = p("link-button"), u = p("tiny-button"), _ = p("close-icon"), C = p("monaco-editor");
  return D(), P("div", ut, [
    l("div", mt, [
      l("div", pt, [
        t[0] || (t[0] = l("span", { class: "title" }, "页面 JS", -1)),
        g(d, { href: n.docsUrl }, null, 8, ["href"])
      ]),
      l("div", gt, [
        g(u, {
          type: "primary",
          class: "save-btn",
          onClick: n.saveMethods
        }, {
          default: A(() => [
            t[1] || (t[1] = l("span", null, "保存", -1)),
            T(l("span", ft, null, 512), [
              [F, n.state.isChanged]
            ])
          ]),
          _: 1
        }, 8, ["onClick"]),
        g(_, { onClose: n.close }, null, 8, ["onClose"])
      ])
    ]),
    l("div", ht, [
      g(C, {
        ref: "monaco",
        value: n.state.script,
        options: n.options,
        onChange: n.change,
        onEditorDidMount: n.editorDidMount
      }, null, 8, ["value", "options", "onChange", "onEditorDidMount"])
    ])
  ]);
}
const _t = /* @__PURE__ */ lt(dt, [["render", vt], ["__scopeId", "data-v-58406856"]]), xt = {
  id: "PageController",
  title: "页面 JS",
  icon: "plugin-icon-js",
  align: "top",
  api: at,
  component: _t,
  confirm: "close"
  // 当点击插件栏切换或关闭前是否需要确认, 会调用插件中confirm值指定的方法，e.g. 此处指向 close方法，会调用插件的close方法执行确认逻辑
};
export {
  xt as default
};
